// BenchMark.cpp : implementation file
//

#include "stdafx.h"
#include "Cryptest.h"
#include "BenchMark.h"

#include "Bench.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBenchMark dialog


CBenchMark::CBenchMark(CWnd* pParent /*=NULL*/)
	: CDialog(CBenchMark::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBenchMark)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBenchMark::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBenchMark)
	DDX_Control(pDX, LIST_BENCH_MARK_OPS, m_lcBenchMarkOps);
	DDX_Control(pDX, LIST_BENCH_MARK, m_lcBenchMark);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBenchMark, CDialog)
	//{{AFX_MSG_MAP(CBenchMark)
	ON_WM_CLOSE()
	ON_BN_CLICKED(BTN_EXIT, OnExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBenchMark message handlers

BOOL CBenchMark::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CCryptestApp* pcCryptest = (CCryptestApp*) AfxGetApp();

	// Setup the column headings
	CRect rect;
	m_lcBenchMark.GetClientRect(&rect);

	// Setup the list control
	ListView_SetExtendedListViewStyle(m_lcBenchMark.m_hWnd, LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP);
	ListView_SetExtendedListViewStyle(m_lcBenchMarkOps.m_hWnd, LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP);
		
	m_lcBenchMark.InsertColumn( 0, _T("Algorithm"), LVCFMT_LEFT, 256);
	m_lcBenchMark.InsertColumn( 1, _T("Bytes Processed"), LVCFMT_RIGHT, 92);
	m_lcBenchMark.InsertColumn( 2, _T("Time Taken"), LVCFMT_RIGHT, 72);
	m_lcBenchMark.InsertColumn( 3, _T("MB(2^20)/Sec"), LVCFMT_RIGHT, 85);

	m_lcBenchMarkOps.InsertColumn( 0, _T("Operation"), LVCFMT_LEFT, 290);
	m_lcBenchMarkOps.InsertColumn( 1, _T("Iterations"), LVCFMT_RIGHT, 55);
	m_lcBenchMarkOps.InsertColumn( 2, _T("Total Time"), LVCFMT_RIGHT, 65);
	m_lcBenchMarkOps.InsertColumn( 3, _T("MSec/Operation "), LVCFMT_RIGHT, 95);

	pcCryptest->m_lcBenchMark = &m_lcBenchMark;
	pcCryptest->m_lcBenchMarkOps = &m_lcBenchMarkOps;

	GetDlgItem(EDT_SECONDS)->SetWindowText(_T("0.1"));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBenchMark::OnOK() 
{
	CCryptestApp* pcCryptest = (CCryptestApp*) AfxGetApp();

	CWaitCursor wait;
	m_lcBenchMark.DeleteAllItems();
	m_lcBenchMarkOps.DeleteAllItems();
	pcCryptest->m_lcBenchMark->DeleteAllItems();
	pcCryptest->m_lcBenchMarkOps->DeleteAllItems();
	pcCryptest->m_nBMItemCnt = 0;
	pcCryptest->m_nBMItemCntOps = 0;

	CString csSeconds = _T("");
	GetDlgItem(EDT_SECONDS)->GetWindowText(csSeconds);

	if (!csSeconds.IsEmpty())
	{
		double dSec = atof(csSeconds);
		BenchMarkAll(dSec);
		GetDlgItem(IDC_STATIC_TP)->SetWindowText(pcCryptest->m_csThroughPut);
	}
	else
	{
		BenchMarkAll();
		GetDlgItem(IDC_STATIC_TP)->SetWindowText(pcCryptest->m_csThroughPut);
	}
}

void CBenchMark::OnCancel() 
{
	//CDialog::OnCancel();
}

void CBenchMark::OnClose() 
{
	CDialog::OnOK();
}

void CBenchMark::OnExit() 
{
	OnClose();
}

