// Cryptest.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Cryptest.h"
#include "CryptestDlg.h"

#include "pch.h"

#include "default.h"

#include "sha.h"
#include "hex.h"        // HexEncoder
#include "md5.h"
#include "ripemd.h"
#include "gzip.h"
#include "ida.h"
#include "files.h"
#include "rsa.h"
#include "rng.h"
#include "randpool.h"

#include <string>
#include <iostream>


#include "misc.h"

//#include <winsock2.h>
#include "socketft.h"

//#include "validate.h"
//#include "bench.h"

#include <direct.h>
//#include <ostream.h>
//#include <stdio.h>
//#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCryptestApp

BEGIN_MESSAGE_MAP(CCryptestApp, CWinApp)
	//{{AFX_MSG_MAP(CCryptestApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCryptestApp construction

CCryptestApp::CCryptestApp()
{
	m_lcValidate = NULL;
	m_lcBenchMark = NULL;
	m_lcBenchMarkOps = NULL;
	m_nItemCnt = 0;
	m_nFSItemCnt = 0;
	m_nBMItemCnt = 0;
	m_nBMItemCntOps = 0;
	m_nTFItemCnt = 0;
	m_csThroughPut = _T("");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCryptestApp object

CCryptestApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CCryptestApp initialization

BOOL CCryptestApp::InitInstance()
{
//	if (!AfxSocketInit())
//	{
//		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
//		return FALSE;
//	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CCryptestDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}


/****************************************************************************
**
**	Function:	Split
**
**  Purpose:
**
****************************************************************************/
void CCryptestApp::Split(CString Source, CString Deliminator, CStringArray& AddIt, BOOL bAddEmpty)
{
	// initialize the variables
	CString		 newCString = Source;
	CString		 tmpCString = "";
	CString		 AddCString = "";

	int pos1 = 0;
	int pos = 0;

	AddIt.RemoveAll();

	if (Deliminator.IsEmpty()) {
		// Add default [comma] if empty!
		// acknowledgement: Prasad [gprasad@rti.ie]
		Deliminator = ","; 
	}

	// do this loop as long as you have a deliminator
	do {
		// set to zero
		pos1 = 0;
		// position of deliminator starting at pos1 (0)
		pos = newCString.Find(Deliminator, pos1);
		// if the deliminator is found...
		if ( pos != -1 ) {

			// load a new var with the info left
			// of the position
			CString AddCString = newCString.Left(pos);// - 1);

			if (!AddCString.IsEmpty()) {
				// if there is a string to add, then
				// add it to the Array
				AddIt.Add(AddCString);
			}
			else if (bAddEmpty) {
				// if empty strings are ok, then add them
				AddIt.Add(AddCString);
			}

			// make a copy of the of this var. with the info
			// right of the deliminator
			tmpCString = newCString.Mid(pos + Deliminator.GetLength());
			
			// reset this var with new info
			newCString = tmpCString;
		}
	} while ( pos != -1 );
	
	if ((!newCString.IsEmpty()) ||(bAddEmpty)) {
		// as long as the variable is not emty, add it
		AddIt.Add(newCString);
	}
}


using namespace CryptoPP;
using namespace std ;

CString CCryptestApp::EncryptString(const char *instr, const char *passPhrase)
{

	char szOutstr[1024];
	std::string outstr;

	DefaultEncryptorWithMAC encryptor(passPhrase, new HexEncoder(new StringSink(outstr)));
	encryptor.Put((byte *)instr, strlen(instr));
	encryptor.MessageEnd();

	sprintf(szOutstr,"%s", outstr.c_str());
	CString csRet(szOutstr);
	return csRet;
}


CString CCryptestApp::DecryptString(const char *instr, const char *passPhrase)
{

	char szOutstr[1024];
	std::string outstr;

	HexDecoder decryptor(new DefaultDecryptorWithMAC(passPhrase, new StringSink(outstr)));
	decryptor.Put((byte *)instr, strlen(instr));
	decryptor.MessageEnd();

	sprintf(szOutstr,"%s", outstr.c_str());

	CString csRet = szOutstr;
	return csRet;
}


void CCryptestApp::GenerateRSAKey(unsigned int keyLength, const char *privFilename, const char *pubFilename, const char *seed)
{
	RandomPool randPool;
	randPool.Put((byte *)seed, strlen(seed));

	RSAES_OAEP_SHA_Decryptor priv(randPool, keyLength);
	HexEncoder privFile(new FileSink(privFilename));
	priv.DEREncode(privFile);
	privFile.MessageEnd();

	RSAES_OAEP_SHA_Encryptor pub(priv);
	HexEncoder pubFile(new FileSink(pubFilename));
	pub.DEREncode(pubFile);
	pubFile.MessageEnd();
}

CString CCryptestApp::RSAEncryptString(const char *pubFilename, const char *seed, const char *message)
{
	FileSource pubFile(pubFilename, true, new HexDecoder);
	RSAES_OAEP_SHA_Encryptor pub(pubFile);

	if (strlen(message) > pub.MaxPlainTextLength())
		return (char *)"Error: Message is too long for this key!";

	RandomPool randPool;
	randPool.Put((byte *)seed, strlen(seed));

	char *outstr = new char[2*pub.CipherTextLength()+1];
	pub.Encrypt(randPool, (byte *)message, strlen(message), (byte *)outstr);

	HexEncoder hexEncoder;
	hexEncoder.Put((byte *)outstr, pub.CipherTextLength());
	hexEncoder.MessageEnd();
	hexEncoder.Get((byte *)outstr, 2*pub.CipherTextLength());

	outstr[2*pub.CipherTextLength()] = 0;
	CString csRet(outstr);
	delete [] outstr;
	return csRet;
}

CString CCryptestApp::RSADecryptString(const char *privFilename, const char *ciphertext)
{
	FileSource privFile(privFilename, true, new HexDecoder);
	RSAES_OAEP_SHA_Decryptor priv(privFile);

	HexDecoder hexDecoder;
	hexDecoder.Put((byte *)ciphertext, strlen(ciphertext));
	hexDecoder.MessageEnd();
	SecByteBlock buf(priv.CipherTextLength());
	hexDecoder.Get(buf, priv.CipherTextLength());

	char *outstr = new char[priv.MaxPlainTextLength()+1];
	unsigned messageLength = priv.Decrypt(buf, (byte *)outstr);
	outstr[messageLength] = 0;
	CString csRet(outstr);
	delete [] outstr;
	return csRet;
}

void CCryptestApp::RSASignFile(const char *privFilename, const char *messageFilename, const char *signatureFilename)
{
	FileSource privFile(privFilename, true, new HexDecoder);
	RSASSA_PKCS1v15_SHA_Signer priv(privFile);
	NullRNG rng;	// RSASSA_PKCS1v15_SHA_Signer ignores the rng. Use a real RNG for other signature schemes!
	FileSource f(messageFilename, true, new SignerFilter(rng, priv, new HexEncoder(new FileSink(signatureFilename))));
}

bool CCryptestApp::RSAVerifyFile(const char *pubFilename, const char *messageFilename, const char *signatureFilename)
{
	FileSource pubFile(pubFilename, true, new HexDecoder);
	RSASSA_PKCS1v15_SHA_Verifier pub(pubFile);

	FileSource signatureFile(signatureFilename, true, new HexDecoder);
	if (signatureFile.MaxRetrievable() != pub.SignatureLength())
		return false;
	SecByteBlock signature(pub.SignatureLength());
	signatureFile.Get(signature, signature.size);

	VerifierFilter *verifierFilter = new VerifierFilter(pub);
	verifierFilter->PutSignature(signature);
	FileSource f(messageFilename, true, verifierFilter);

	byte result = 0;
	f.Get(result);
	return result == 1;
}

void CCryptestApp::EncryptFile(const char *in, const char *out, const char *passPhrase)
{
	FileSource f(in, true, new DefaultEncryptorWithMAC(passPhrase, new FileSink(out)));
}

void CCryptestApp::DecryptFile(const char *in, const char *out, const char *passPhrase)
{
	FileSource f(in, true, new DefaultDecryptorWithMAC(passPhrase, new FileSink(out)));
}

void CCryptestApp::SecretShareFile(int threshold, int nShares, const char *filename, const char *seed)
{
	assert(nShares<=1000);

	RandomPool rng;
	rng.Put((byte *)seed, strlen(seed));

	ChannelSwitch *channelSwitch;
	FileSource source(filename, false, new SecretSharing(rng, threshold, nShares, channelSwitch = new ChannelSwitch));

	vector_member_ptrs<FileSink> fileSinks(nShares);
	string channel;
	for (unsigned int i=0; i<nShares; i++)
	{
		char extension[5] = ".000";
		extension[1]='0'+byte(i/100);
		extension[2]='0'+byte((i/10)%10);
		extension[3]='0'+byte(i%10);
		fileSinks[i].reset(new FileSink((string(filename)+extension).c_str()));

		channel = WordToString<word32>(i);
		fileSinks[i]->Put((byte *)channel.data(), 4);
		channelSwitch->AddRoute(channel, *fileSinks[i], BufferedTransformation::NULL_CHANNEL);
	}

	source.PumpAll();
}

void CCryptestApp::SecretRecoverFile(int threshold, const char *outFilename, char *const *inFilenames)
{
	assert(threshold<=1000);

	SecretRecovery recovery(threshold, new FileSink(outFilename));

	vector_member_ptrs<FileSource> fileSources(threshold);
	SecByteBlock channel(4);
	unsigned int i;
	for (i=0; i<threshold; i++)
	{
		fileSources[i].reset(new FileSource(inFilenames[i], false));
		fileSources[i]->Pump(4);
		fileSources[i]->Get(channel, 4);
		fileSources[i]->Attach(new ChannelSwitch(recovery, string((char *)channel.ptr, 4)));
	}

	while (fileSources[0]->Pump(256))
		for (i=1; i<threshold; i++)
			fileSources[i]->Pump(256);

	for (i=0; i<threshold; i++)
		fileSources[i]->PumpAll();
}

void CCryptestApp::InformationDisperseFile(int threshold, int nShares, const char *filename)
{
	assert(nShares<=1000);

	ChannelSwitch *channelSwitch;
	FileSource source(filename, false, new InformationDispersal(threshold, nShares, channelSwitch = new ChannelSwitch));

	vector_member_ptrs<FileSink> fileSinks(nShares);
	string channel;
	for (unsigned int i=0; i<nShares; i++)
	{
		char extension[5] = ".000";
		extension[1]='0'+byte(i/100);
		extension[2]='0'+byte((i/10)%10);
		extension[3]='0'+byte(i%10);
		fileSinks[i].reset(new FileSink((string(filename)+extension).c_str()));

		channel = WordToString<word32>(i);
		fileSinks[i]->Put((byte *)channel.data(), 4);
		channelSwitch->AddRoute(channel, *fileSinks[i], BufferedTransformation::NULL_CHANNEL);
	}

	source.PumpAll();
}

void CCryptestApp::InformationRecoverFile(int threshold, const char *outFilename, char *const *inFilenames)
{
	assert(threshold<=1000);

	InformationRecovery recovery(threshold, new FileSink(outFilename));

	vector_member_ptrs<FileSource> fileSources(threshold);
	SecByteBlock channel(4);
	unsigned int i;
	for (i=0; i<threshold; i++)
	{
		fileSources[i].reset(new FileSource(inFilenames[i], false));
		fileSources[i]->Pump(4);
		fileSources[i]->Get(channel, 4);
		fileSources[i]->Attach(new ChannelSwitch(recovery, string((char *)channel.ptr, 4)));
	}

	while (fileSources[0]->Pump(256))
		for (i=1; i<threshold; i++)
			fileSources[i]->Pump(256);

	for (i=0; i<threshold; i++)
		fileSources[i]->PumpAll();
}

void CCryptestApp::GzipFile(const char *in, const char *out, int deflate_level)
{
	FileSource(in, true, new Gzip(new FileSink(out), deflate_level));
}

void CCryptestApp::GunzipFile(const char *in, const char *out)
{
	FileSource(in, true, new Gunzip(new FileSink(out)));
}

void CCryptestApp::DigestFile(const char *filename)
{
	m_lcFileStuff->DeleteAllItems();
	m_nFSItemCnt = 0;

	// *******************************************************************
	// START Digests
	// *******************************************************************
	MD5 md5;
	HashFilter md5Filter(md5, new HexEncoder);
	SHA sha;
	HashFilter shaFilter(sha, new HexEncoder);
	RIPEMD160 ripemd;
	HashFilter ripemdFilter(ripemd, new HexEncoder);
	SHA256 sha256;
	HashFilter sha256Filter(sha256, new HexEncoder);
	SHA512 sha512;
	HashFilter sha512Filter(sha512, new HexEncoder);

	ChannelSwitch *channelSwitch;
	FileSource file(filename, false, channelSwitch = new ChannelSwitch);
	channelSwitch->AddDefaultRoute(md5Filter);
	channelSwitch->AddDefaultRoute(shaFilter);
	channelSwitch->AddDefaultRoute(ripemdFilter);
	channelSwitch->AddDefaultRoute(sha256Filter);
	channelSwitch->AddDefaultRoute(sha512Filter);
	file.PumpAll();

	// Get the size of the Digest String
	int nSHA512Max = (int)sha512Filter.MaxRetrievable();
	int nSHA256Max = (int)sha256Filter.MaxRetrievable();
	int nRIPEMD160Max = (int)ripemdFilter.MaxRetrievable();
	int nSHA1Max = (int)shaFilter.MaxRetrievable();
	int nMD5Max = (int)md5Filter.MaxRetrievable();

	// Set the size of the Digest String Pointer
	BYTE *bSHA512Ptr = new BYTE [nSHA512Max];
	BYTE *bSHA256Ptr = new BYTE [nSHA256Max];
	BYTE *bRIPEMD160Ptr = new BYTE [nRIPEMD160Max];
	BYTE *bSHA1Ptr = new BYTE [nSHA1Max];
	BYTE *bMD5Ptr = new BYTE [nMD5Max];

	// Get the Digest String
	sha512Filter.Get(bSHA512Ptr, nSHA512Max);
	sha256Filter.Get(bSHA256Ptr, nSHA256Max);
	ripemdFilter.Get(bRIPEMD160Ptr, nRIPEMD160Max);
	shaFilter.Get(bSHA1Ptr, nSHA1Max);
	md5Filter.Get(bMD5Ptr, nMD5Max);

	// Show the Digest String in the ListCtrl
	CString csTmp = _T("");
	CString csBytePtr = _T("");

	// *******************************************************************
	// MD5 Digest
	// *******************************************************************
	m_lcFileStuff->InsertItem(m_nFSItemCnt,_T("MD5"));
	csTmp.Format("%i", nMD5Max);
	m_lcFileStuff->SetItemText(m_nFSItemCnt,1,csTmp);
	csTmp = _T("");
	csBytePtr.Format("%s", (LPCTSTR)bMD5Ptr);
	csTmp.Format("%s", csBytePtr.Left(nMD5Max));
	m_lcFileStuff->SetItemText(m_nFSItemCnt,2,csTmp);
	m_nFSItemCnt++;
	csTmp = _T("");
	csBytePtr = _T("");
	// *******************************************************************
	// RIPEMD-160 Digest
	// *******************************************************************
	m_lcFileStuff->InsertItem(m_nFSItemCnt,_T("RIPEMD-160"));
	csTmp.Format("%i", nRIPEMD160Max);
	m_lcFileStuff->SetItemText(m_nFSItemCnt,1,csTmp);
	csTmp = _T("");
	csBytePtr.Format("%s", (LPCTSTR)bRIPEMD160Ptr);
	csTmp.Format("%s", csBytePtr.Left(nRIPEMD160Max));
	m_lcFileStuff->SetItemText(m_nFSItemCnt,2,csTmp);
	m_nFSItemCnt++;
	csTmp = _T("");
	csBytePtr = _T("");
	// *******************************************************************
	// SHA Digest
	// *******************************************************************
	m_lcFileStuff->InsertItem(m_nFSItemCnt,_T("SHA-1"));
	csTmp.Format("%i", nSHA1Max);
	m_lcFileStuff->SetItemText(m_nFSItemCnt,1,csTmp);
	csTmp = _T("");
	csBytePtr.Format("%s", (LPCTSTR)bSHA1Ptr);
	csTmp.Format("%s", csBytePtr.Left(nSHA1Max));
	m_lcFileStuff->SetItemText(m_nFSItemCnt,2,csTmp);
	m_nFSItemCnt++;
	csTmp = _T("");
	csBytePtr = _T("");
	// *******************************************************************
	// SHA-256 Digest
	// *******************************************************************
	m_lcFileStuff->InsertItem(m_nFSItemCnt,_T("SHA-256"));
	csTmp.Format("%i", nSHA256Max);
	m_lcFileStuff->SetItemText(m_nFSItemCnt,1,csTmp);
	csTmp = _T("");
	csBytePtr.Format("%s", (LPCTSTR)bSHA256Ptr);
	csTmp.Format("%s", csBytePtr.Left(nSHA256Max));
	m_lcFileStuff->SetItemText(m_nFSItemCnt,2,csTmp);
	m_nFSItemCnt++;
	csTmp = _T("");
	csBytePtr = _T("");
	// *******************************************************************
	// SHA-512 Digest
	// *******************************************************************
	m_lcFileStuff->InsertItem(m_nFSItemCnt,_T("SHA-512"));
	csTmp.Format("%i", nSHA512Max);
	m_lcFileStuff->SetItemText(m_nFSItemCnt,1,csTmp);
	csTmp = _T("");
	csBytePtr.Format("%s", (LPCTSTR)bSHA512Ptr);
	csTmp.Format("%s", csBytePtr.Left(nSHA512Max));
	m_lcFileStuff->SetItemText(m_nFSItemCnt,2,csTmp);
	m_nFSItemCnt++;
	csTmp = _T("");
	csBytePtr = _T("");
	// *******************************************************************
	// END Digests
	// *******************************************************************

	// Clean up!
	delete [] bMD5Ptr;
	delete [] bRIPEMD160Ptr;
	delete [] bSHA1Ptr;
	delete [] bSHA256Ptr;
	delete [] bSHA512Ptr;

}

void CCryptestApp::ForwardTcpPort(const char *sourcePortName, const char *destinationHost, const char *destinationPortName)
{
//#ifdef SOCKETS_AVAILABLE
	SocketsInitializer sockInit;

	Socket sockListen, sockSource, sockDestination;

	CString csSPort = sourcePortName;
	CString csDHost = destinationHost;
	CString csDPort = destinationPortName;

	int sourcePort = Socket::PortNameToNumber(sourcePortName);
	int destinationPort = Socket::PortNameToNumber(destinationPortName);

	sockListen.Create();
	sockListen.Bind(sourcePort);

	m_lcSockets->Invalidate(TRUE);
	CString csListData = _T("");
	csListData.Format("Listing on port %s...", csSPort);
	m_lcSockets->InsertItem(m_nTFItemCnt, csListData);
	m_nTFItemCnt++;
	csListData = _T("");
	m_lcSockets->RedrawWindow();

	sockListen.Listen();

	sockListen.Accept(sockSource);

	m_lcSockets->Invalidate(TRUE);
	csListData.Format("Connection accepted on port %s...", csSPort);
	m_lcSockets->InsertItem(m_nTFItemCnt, csListData);
	m_nTFItemCnt++;
	csListData = _T("");
	m_lcSockets->RedrawWindow();

	m_lcSockets->Invalidate(TRUE);
	csListData.Format("Making connection to %s, port %s...", csDHost, csDPort);
	m_lcSockets->InsertItem(m_nTFItemCnt, csListData);
	m_nTFItemCnt++;
	csListData = _T("");
	m_lcSockets->RedrawWindow();

	sockDestination.Create();
	sockDestination.Connect(destinationHost, destinationPort);

	m_lcSockets->Invalidate(TRUE);
	csListData.Format("Connection made to %s, starting to forward...", csDHost);
	m_lcSockets->InsertItem(m_nTFItemCnt, csListData);
	m_nTFItemCnt++;
	csListData = _T("");
	m_lcSockets->RedrawWindow();

	SocketSource out(sockSource, false, new SocketSink(sockDestination));
	SocketSource in(sockDestination, false, new SocketSink(sockSource));

	while (!(out.EofReceived() && in.EofReceived()))
	{
		fd_set fds;
		FD_ZERO(&fds);
		if (!out.EofReceived())
			FD_SET(out, &fds);
		if (!in.EofReceived())
			FD_SET(in, &fds);
		select(FD_SETSIZE, &fds, NULL, NULL, NULL);

		if (FD_ISSET(out, &fds))
		{
			out.TimedPump(0);
			if (out.EofReceived())
			{
				m_lcSockets->Invalidate(TRUE);
				csListData.Format("EOF received on source socket.");
				m_lcSockets->InsertItem(m_nTFItemCnt, csListData);
				m_nTFItemCnt++;
				csListData = _T("");
				m_lcSockets->RedrawWindow();
				out.PumpAll();	// this will shutdown the attached SocketSink
			}
		}
		if (FD_ISSET(in, &fds))
		{
			in.TimedPump(0);
			if (in.EofReceived())
			{
				m_lcSockets->Invalidate(TRUE);
				csListData.Format("EOF received on destination socket.");
				m_lcSockets->InsertItem(m_nTFItemCnt, csListData);
				m_nTFItemCnt++;
				csListData = _T("");
				m_lcSockets->RedrawWindow();
				in.PumpAll();	// this will shutdown the attached SocketSink
			}
		}
	}
//#else
//	cout << "Sockets not available on this system.\n";
//	exit(-1);
//#endif
}
