// Validation.cpp : implementation file
//

#include "stdafx.h"
#include "Cryptest.h"
#include "Validation.h"

#include "Validate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CValidation dialog


CValidation::CValidation(CWnd* pParent /*=NULL*/)
	: CDialog(CValidation::IDD, pParent)
{
	//{{AFX_DATA_INIT(CValidation)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_bValidateAll = TRUE;
}


void CValidation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CValidation)
	DDX_Control(pDX, CHK_XTRDH, m_chkXtrdh);
	DDX_Control(pDX, CHK_XMACC, m_chkXmacc);
	DDX_Control(pDX, CHK_TWOFISH, m_chkTwofish);
	DDX_Control(pDX, CHK_TIGER, m_chkTiger);
	DDX_Control(pDX, CHK_TEST_SETTINGS, m_chkTestSettings);
	DDX_Control(pDX, CHK_TEST_OS_RNG, m_chkTestOSRng);
	DDX_Control(pDX, CHK_SQUARE, m_chkSquare);
	DDX_Control(pDX, CHK_SKIPJACK, m_chkSkipjack);
	DDX_Control(pDX, CHK_SHARK, m_chkShark);
	DDX_Control(pDX, CHK_SHA2, m_chkSha2);
	DDX_Control(pDX, CHK_SHA, m_chkSha);
	DDX_Control(pDX, CHK_SERPENT, m_chkSerpent);
	DDX_Control(pDX, CHK_SEAL, m_chkSeal);
	DDX_Control(pDX, CHK_SAFER, m_chkSafer);
	DDX_Control(pDX, CHK_RW, m_chkRw);
	DDX_Control(pDX, CHK_RSA, m_chkRsa);
	DDX_Control(pDX, CHK_RIPEMD, m_chkRipemd);
	DDX_Control(pDX, CHK_RIJNDAEL, m_chkRijndael);
	DDX_Control(pDX, CHK_RC6, m_chkRc6);
	DDX_Control(pDX, CHK_RC5, m_chkRc5);
	DDX_Control(pDX, CHK_RC2, m_chkRc2);
	DDX_Control(pDX, CHK_RABIN, m_chkRabin);
	DDX_Control(pDX, CHK_PANAMA, m_chkPanama);
	DDX_Control(pDX, CHK_NR, m_chkNr);
	DDX_Control(pDX, CHK_MQV, m_chkMqv);
	DDX_Control(pDX, CHK_MD5MAC, m_chkMd5mac);
	DDX_Control(pDX, CHK_MD5, m_chkMd5);
	DDX_Control(pDX, CHK_MD2, m_chkMd2);
	DDX_Control(pDX, CHK_MARS, m_chkMars);
	DDX_Control(pDX, CHK_LUCELG, m_chkLucelg);
	DDX_Control(pDX, CHK_LUCDIF, m_chkLucdif);
	DDX_Control(pDX, CHK_LUC, m_chkLuc);
	DDX_Control(pDX, CHK_IDEA, m_chkIdea);
	DDX_Control(pDX, CHK_HMAC, m_chkHmac);
	DDX_Control(pDX, CHK_HAVAL, m_chkHaval);
	DDX_Control(pDX, CHK_GOST, m_chkGost);
	DDX_Control(pDX, CHK_EIGAMAL, m_chkEigamal);
	DDX_Control(pDX, CHK_ECP, m_chkEcp);
	DDX_Control(pDX, CHK_ECDSA, m_chkEcdsa);
	DDX_Control(pDX, CHK_EC2N, m_chkEc2n);
	DDX_Control(pDX, CHK_DSA, m_chkDsa);
	DDX_Control(pDX, CHK_DIAMOND2, m_chkDiamond2);
	DDX_Control(pDX, CHK_DH, m_chkDh);
	DDX_Control(pDX, CHK_DES, m_chkDes);
	DDX_Control(pDX, CHK_CRC32, m_chkCrc32);
	DDX_Control(pDX, CHK_CIPHER, m_chkCipher);
	DDX_Control(pDX, CHK_CAST, m_chkCast);
	DDX_Control(pDX, CHK_BLUM_GOLDWASSER, m_chkBlumGoldwasser);
	DDX_Control(pDX, CHK_BLOWFISH, m_chkBlowfish);
	DDX_Control(pDX, CHK_BBS, m_chkBbs);
	DDX_Control(pDX, CHK_ARC4, m_chkArc4);
	DDX_Control(pDX, CHK_ADLER32, m_chkAdler32);
	DDX_Control(pDX, CHK_3WAY, m_chk3Way);
	DDX_Control(pDX, LIST_VALIDATE, m_lcValidate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CValidation, CDialog)
	//{{AFX_MSG_MAP(CValidation)
	ON_WM_CLOSE()
	ON_BN_CLICKED(BTN_EXIT, OnExit)
	ON_BN_CLICKED(RAD_VALIDATE_ALL, OnValidateAll)
	ON_BN_CLICKED(RAD_VALIDATE_PICK, OnValidatePick)
	ON_BN_CLICKED(CHK_3WAY, On3way)
	ON_BN_CLICKED(CHK_ADLER32, OnAdler32)
	ON_BN_CLICKED(CHK_ARC4, OnArc4)
	ON_BN_CLICKED(CHK_BBS, OnBbs)
	ON_BN_CLICKED(CHK_BLOWFISH, OnBlowfish)
	ON_BN_CLICKED(CHK_BLUM_GOLDWASSER, OnBlumGoldwasser)
	ON_BN_CLICKED(CHK_CAST, OnCast)
	ON_BN_CLICKED(CHK_CIPHER, OnCipher)
	ON_BN_CLICKED(CHK_CRC32, OnCrc32)
	ON_BN_CLICKED(CHK_DES, OnDes)
	ON_BN_CLICKED(CHK_DH, OnDh)
	ON_BN_CLICKED(CHK_DIAMOND2, OnDiamond2)
	ON_BN_CLICKED(CHK_DSA, OnDsa)
	ON_BN_CLICKED(CHK_EC2N, OnEc2n)
	ON_BN_CLICKED(CHK_ECDSA, OnEcdsa)
	ON_BN_CLICKED(CHK_ECP, OnEcp)
	ON_BN_CLICKED(CHK_EIGAMAL, OnEigamal)
	ON_BN_CLICKED(CHK_GOST, OnGost)
	ON_BN_CLICKED(CHK_HAVAL, OnHaval)
	ON_BN_CLICKED(CHK_HMAC, OnHmac)
	ON_BN_CLICKED(CHK_IDEA, OnIdea)
	ON_BN_CLICKED(CHK_LUC, OnLuc)
	ON_BN_CLICKED(CHK_LUCDIF, OnLucdif)
	ON_BN_CLICKED(CHK_LUCELG, OnLucelg)
	ON_BN_CLICKED(CHK_MARS, OnMars)
	ON_BN_CLICKED(CHK_MD2, OnMd2)
	ON_BN_CLICKED(CHK_MD5, OnMd5)
	ON_BN_CLICKED(CHK_MD5MAC, OnMd5mac)
	ON_BN_CLICKED(CHK_MQV, OnMqv)
	ON_BN_CLICKED(CHK_NR, OnNr)
	ON_BN_CLICKED(CHK_PANAMA, OnPanama)
	ON_BN_CLICKED(CHK_RABIN, OnRabin)
	ON_BN_CLICKED(CHK_RC2, OnRc2)
	ON_BN_CLICKED(CHK_RC5, OnRc5)
	ON_BN_CLICKED(CHK_RC6, OnRc6)
	ON_BN_CLICKED(CHK_RIJNDAEL, OnRijndael)
	ON_BN_CLICKED(CHK_RIPEMD, OnRipemd)
	ON_BN_CLICKED(CHK_RSA, OnRsa)
	ON_BN_CLICKED(CHK_RW, OnRw)
	ON_BN_CLICKED(CHK_SAFER, OnSafer)
	ON_BN_CLICKED(CHK_SEAL, OnSeal)
	ON_BN_CLICKED(CHK_SERPENT, OnSerpent)
	ON_BN_CLICKED(CHK_SHA, OnSha)
	ON_BN_CLICKED(CHK_SHA2, OnSha2)
	ON_BN_CLICKED(CHK_SHARK, OnShark)
	ON_BN_CLICKED(CHK_SKIPJACK, OnSkipjack)
	ON_BN_CLICKED(CHK_SQUARE, OnSquare)
	ON_BN_CLICKED(CHK_TEST_OS_RNG, OnTestOsRng)
	ON_BN_CLICKED(CHK_TEST_SETTINGS, OnTestSettings)
	ON_BN_CLICKED(CHK_TIGER, OnTiger)
	ON_BN_CLICKED(CHK_TWOFISH, OnTwofish)
	ON_BN_CLICKED(CHK_XMACC, OnXmacc)
	ON_BN_CLICKED(CHK_XTRDH, OnXtrdh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CValidation message handlers

BOOL CValidation::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CCryptestApp* pcCryptest = (CCryptestApp*) AfxGetApp();
	
	// Setup the column headings
	CRect rect;
	m_lcValidate.GetClientRect(&rect);

	// Setup the list control
	ListView_SetExtendedListViewStyle(m_lcValidate.m_hWnd, LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP);
		
	m_lcValidate.InsertColumn( 0, _T("Validation results..."), LVCFMT_LEFT, 505);

	pcCryptest->m_lcValidate = &m_lcValidate;

	OnValidateAll();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CValidation::OnOK() 
{
	CCryptestApp* pcCryptest = (CCryptestApp*) AfxGetApp();

	CWaitCursor wait;
	m_lcValidate.DeleteAllItems();
	pcCryptest->m_lcValidate->DeleteAllItems();

	if (m_bValidateAll)
		ValidateAll();
	else
	{
		bool pass=true;
		for (int n=0; n<m_dwaValidate.GetSize(); n++)
		{
			DWORD dwTmp = m_dwaValidate.GetAt(n);
			pass=Validate((int)dwTmp) && pass;
		}

		m_lcValidate.InsertItem(pcCryptest->m_nItemCnt, _T(""));
		pcCryptest->m_nItemCnt++;

		if (pass)
			m_lcValidate.InsertItem(pcCryptest->m_nItemCnt, _T("All tests passed!"));
		else
			m_lcValidate.InsertItem(pcCryptest->m_nItemCnt, _T("Oops!  Not all tests passed.!"));

	}
	pcCryptest->m_nItemCnt = 0;
}

void CValidation::OnCancel() 
{
	//CDialog::OnCancel();
}

void CValidation::OnClose() 
{
	CDialog::OnOK();
}

void CValidation::OnExit() 
{
	OnClose();
}

void CValidation::OnValidateAll() 
{
	CheckRadioButton(1049, 1050, 1049);
	m_bValidateAll = TRUE;
	m_chkXtrdh.SetCheck(1);
	m_chkXmacc.SetCheck(1);
	m_chkTwofish.SetCheck(1);
	m_chkTiger.SetCheck(1);
	m_chkTestSettings.SetCheck(1);
	m_chkTestOSRng.SetCheck(1);
	m_chkSquare.SetCheck(1);
	m_chkSkipjack.SetCheck(1);
	m_chkShark.SetCheck(1);
	m_chkSha2.SetCheck(1);
	m_chkSha.SetCheck(1);
	m_chkSerpent.SetCheck(1);
	m_chkSeal.SetCheck(1);
	m_chkSafer.SetCheck(1);
	m_chkRw.SetCheck(1);
	m_chkRsa.SetCheck(1);
	m_chkRipemd.SetCheck(1);
	m_chkRijndael.SetCheck(1);
	m_chkRc6.SetCheck(1);
	m_chkRc5.SetCheck(1);
	m_chkRc2.SetCheck(1);
	m_chkRabin.SetCheck(1);
	m_chkPanama.SetCheck(1);
	m_chkNr.SetCheck(1);
	m_chkMqv.SetCheck(1);
	m_chkMd5mac.SetCheck(1);
	m_chkMd5.SetCheck(1);
	m_chkMd2.SetCheck(1);
	m_chkMars.SetCheck(1);
	m_chkLucelg.SetCheck(1);
	m_chkLucdif.SetCheck(1);
	m_chkLuc.SetCheck(1);
	m_chkIdea.SetCheck(1);
	m_chkHmac.SetCheck(1);
	m_chkHaval.SetCheck(1);
	m_chkGost.SetCheck(1);
	m_chkEigamal.SetCheck(1);
	m_chkEcp.SetCheck(1);
	m_chkEcdsa.SetCheck(1);
	m_chkEc2n.SetCheck(1);
	m_chkDsa.SetCheck(1);
	m_chkDiamond2.SetCheck(1);
	m_chkDh.SetCheck(1);
	m_chkDes.SetCheck(1);
	m_chkCrc32.SetCheck(1);
	m_chkCipher.SetCheck(1);
	m_chkCast.SetCheck(1);
	m_chkBlumGoldwasser.SetCheck(1);
	m_chkBlowfish.SetCheck(1);
	m_chkBbs.SetCheck(1);
	m_chkArc4.SetCheck(1);
	m_chkAdler32.SetCheck(1);
	m_chk3Way.SetCheck(1);

	m_dwaValidate.RemoveAll();
}

void CValidation::OnValidatePick() 
{
	CheckRadioButton(1049, 1050, 1050);
	m_bValidateAll = FALSE;

	m_chkXtrdh.SetCheck(0);
	m_chkXmacc.SetCheck(0);
	m_chkTwofish.SetCheck(0);
	m_chkTiger.SetCheck(0);
	m_chkTestSettings.SetCheck(0);
	m_chkTestOSRng.SetCheck(0);
	m_chkSquare.SetCheck(0);
	m_chkSkipjack.SetCheck(0);
	m_chkShark.SetCheck(0);
	m_chkSha2.SetCheck(0);
	m_chkSha.SetCheck(0);
	m_chkSerpent.SetCheck(0);
	m_chkSeal.SetCheck(0);
	m_chkSafer.SetCheck(0);
	m_chkRw.SetCheck(0);
	m_chkRsa.SetCheck(0);
	m_chkRipemd.SetCheck(0);
	m_chkRijndael.SetCheck(0);
	m_chkRc6.SetCheck(0);
	m_chkRc5.SetCheck(0);
	m_chkRc2.SetCheck(0);
	m_chkRabin.SetCheck(0);
	m_chkPanama.SetCheck(0);
	m_chkNr.SetCheck(0);
	m_chkMqv.SetCheck(0);
	m_chkMd5mac.SetCheck(0);
	m_chkMd5.SetCheck(0);
	m_chkMd2.SetCheck(0);
	m_chkMars.SetCheck(0);
	m_chkLucelg.SetCheck(0);
	m_chkLucdif.SetCheck(0);
	m_chkLuc.SetCheck(0);
	m_chkIdea.SetCheck(0);
	m_chkHmac.SetCheck(0);
	m_chkHaval.SetCheck(0);
	m_chkGost.SetCheck(0);
	m_chkEigamal.SetCheck(0);
	m_chkEcp.SetCheck(0);
	m_chkEcdsa.SetCheck(0);
	m_chkEc2n.SetCheck(0);
	m_chkDsa.SetCheck(0);
	m_chkDiamond2.SetCheck(0);
	m_chkDh.SetCheck(0);
	m_chkDes.SetCheck(0);
	m_chkCrc32.SetCheck(0);
	m_chkCipher.SetCheck(0);
	m_chkCast.SetCheck(0);
	m_chkBlumGoldwasser.SetCheck(0);
	m_chkBlowfish.SetCheck(0);
	m_chkBbs.SetCheck(0);
	m_chkArc4.SetCheck(0);
	m_chkAdler32.SetCheck(0);
	m_chk3Way.SetCheck(0);

	m_dwaValidate.RemoveAll();
}

void CValidation::ValidateArray(BOOL bAdd, int nNum)
{
	if (bAdd)
		m_dwaValidate.Add((DWORD) nNum);
	else
	{
		for (int n=0; n<m_dwaValidate.GetSize(); n++)
		{
			DWORD dwTmp = m_dwaValidate.GetAt(n);
			if (dwTmp == (DWORD)nNum)
			{
				m_dwaValidate.RemoveAt(n);
				break;
			}
		}
	}
}


void CValidation::On3way() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chk3Way.GetCheck(), 11);
}

void CValidation::OnAdler32() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkAdler32.GetCheck(), 54);
}

void CValidation::OnArc4() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkArc4.GetCheck(), 7);
}

void CValidation::OnBbs() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkBbs.GetCheck(), 12);
}

void CValidation::OnBlowfish() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkBlowfish.GetCheck(), 9);
}

void CValidation::OnBlumGoldwasser() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkBlumGoldwasser.GetCheck(), 21);
}

void CValidation::OnCast() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkCast.GetCheck(), 35);
}

void CValidation::OnCipher() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkCipher.GetCheck(), 47);
}

void CValidation::OnCrc32() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkCrc32.GetCheck(), 48);
}

void CValidation::OnDes() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkDes.GetCheck(), 5);
}

void CValidation::OnDh() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkDh.GetCheck(), 13);
}

void CValidation::OnDiamond2() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkDiamond2.GetCheck(), 10);
}

void CValidation::OnDsa() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkDsa.GetCheck(), 16);
}

void CValidation::OnEc2n() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkEc2n.GetCheck(), 23);
}

void CValidation::OnEcdsa() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkEcdsa.GetCheck(), 49);
}

void CValidation::OnEcp() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkEcp.GetCheck(), 22);
}

void CValidation::OnEigamal() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkEigamal.GetCheck(), 15);
}

void CValidation::OnGost() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkGost.GetCheck(), 25);
}

void CValidation::OnHaval() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkHaval.GetCheck(), 17);
}

void CValidation::OnHmac() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkHmac.GetCheck(), 28);
}

void CValidation::OnIdea() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkIdea.GetCheck(), 6);
}

void CValidation::OnLuc() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkLuc.GetCheck(), 19);
}

void CValidation::OnLucdif() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkLucdif.GetCheck(), 32);
}

void CValidation::OnLucelg() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkLucelg.GetCheck(), 33);
}

void CValidation::OnMars() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkMars.GetCheck(), 39);
}

void CValidation::OnMd2() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkMd2.GetCheck(), 41);
}

void CValidation::OnMd5() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkMd5.GetCheck(), 3);
}

void CValidation::OnMd5mac() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkMd5mac.GetCheck(), 24);
}

void CValidation::OnMqv() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkMqv.GetCheck(), 43);
}

void CValidation::OnNr() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkNr.GetCheck(), 42);
}

void CValidation::OnPanama() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkPanama.GetCheck(), 53);
}

void CValidation::OnRabin() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRabin.GetCheck(), 20);
}

void CValidation::OnRc2() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRc2.GetCheck(), 37);
}

void CValidation::OnRc5() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRc5.GetCheck(), 8);
}

void CValidation::OnRc6() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRc6.GetCheck(), 38);
}

void CValidation::OnRijndael() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRijndael.GetCheck(), 44);
}

void CValidation::OnRipemd() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRipemd.GetCheck(), 27);
}

void CValidation::OnRsa() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRsa.GetCheck(), 14);
}

void CValidation::OnRw() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkRw.GetCheck(), 40);
}

void CValidation::OnSafer() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkSafer.GetCheck(), 18);
}

void CValidation::OnSeal() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkSeal.GetCheck(), 34);
}

void CValidation::OnSerpent() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkSerpent.GetCheck(), 46);
}

void CValidation::OnSha() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkSha.GetCheck(), 4);
}

void CValidation::OnSha2() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkSha2.GetCheck(), 52);
}

void CValidation::OnShark() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkShark.GetCheck(), 30);
}

void CValidation::OnSkipjack() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkSkipjack.GetCheck(), 51);
}

void CValidation::OnSquare() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkSquare.GetCheck(), 36);
}

void CValidation::OnTestOsRng() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkTestOSRng.GetCheck(), 2);
}

void CValidation::OnTestSettings() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkTestSettings.GetCheck(), 1);
}

void CValidation::OnTiger() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkTiger.GetCheck(), 26);
}

void CValidation::OnTwofish() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkTwofish.GetCheck(), 45);
	
}

void CValidation::OnXmacc() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkXmacc.GetCheck(), 50);
	
}

void CValidation::OnXtrdh() 
{
	UpdateData(TRUE);
	ValidateArray((BOOL)m_chkXtrdh.GetCheck(), 29);
	
}

